/*
 * DAO.java
 *
 * Created on 23 de Junho de 2007, 18:14
 * EP de Contabilidade (Projeto Vatan)
 * Classe sendo reutilizada para o projeto CheckProj
 *
 * 
 */

package checklisttool;

/**
 *
 * @author Bruno Alves
 */

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

public class DAO {
    private Connection conexao;
    
    public DAO(String nomeDriver, String urlConexao) {
        try {
            Class.forName(nomeDriver);
        } catch (ClassNotFoundException e) {
            System.err.println("O driver expecificado não foi encontrado.");
            e.printStackTrace();
        }
        
        try {
            conexao = DriverManager.getConnection(urlConexao);
        } catch (SQLException e) {
            System.err.println("Não foi possível conectar ao Banco de Dados");
            e.printStackTrace();
        }
    }
    
    public DAO(String caminho) {
        System.setProperty("jdbc.drivers",
         "sun.jdbc.odbc.JdbcOdbcDriver") ;

        try {
            conexao = DriverManager.getConnection("jdbc:odbc:driver={Microsoft Access Driver (*.mdb)};DBQ=" + caminho);
        } catch (SQLException e) {
            System.err.println("Não foi possível conectar ao Banco de Dados");
            e.printStackTrace();
        }
    }
    
    public void gravar(EntidadeBD ent) {
        try {
            ent.gravar(this);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    
    public void carregar(EntidadeBD ent) {
        ent.carregar(this);
    }
    
    public ResultSet consultar(String sql) {
        Statement s;
        
        try {
            s=conexao.createStatement();
            return s.executeQuery(sql);
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return null;
    }
    
    public void update(String sql) {
        Statement s;
        try {
            s = conexao.createStatement();
            s.executeUpdate(sql);
        } catch (SQLException e) {
            e.printStackTrace();
        } 
    }
    
    public Connection getConexao() {
        return conexao;
    }
    
    public void setConexao(Connection conexao) {
        this.conexao = conexao;
    }
}
